/*
#include "sdl.h"
#include "sdl_image.h"
#include "assert.h"
#include "stdlib.h"
#include "stdarg.h"

extern "C" {
    void __stdcall OutputDebugStringA( const char * );
};

void Printf( const char *fmt,... )
{
    char    Buff[100];
    va_list marker;
    
    va_start( marker,fmt );
    vsprintf( Buff,fmt,marker );
    va_end( marker );
    OutputDebugStringA( Buff );
}



void test( SDL_Surface *screen )
{
    SDL_Surface *intro, *temp;

    temp = IMG_Load("pngbar.png");
    assert(temp);

    intro = SDL_DisplayFormat(temp);
    assert(intro);
    SDL_FreeSurface(temp);

    SDL_SetAlpha(intro, SDL_SRCALPHA, 128);
    SDL_BlitSurface(intro, NULL, screen, NULL);
    SDL_FreeSurface(intro);
}


int main( int argc, char *argv[] )
{
    SDL_Surface *screen;
    int         width, height, bpp;
    Uint32      videoflags;
    SDL_Event   event;
    int         done;

    width = 640; height = 480; bpp = 16;
    videoflags = SDL_SWSURFACE;
    videoflags = SDL_DOUBLEBUF|SDL_HWSURFACE;
    //videoflags |= SDL_FULLSCREEN;

    if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
    {
        fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
        exit(1);
    }

    screen = SDL_SetVideoMode( width, height, bpp, videoflags );
    if ( screen == NULL )
    {
        fprintf( stderr, "Couldn't set display mode: %s\n", SDL_GetError() );
        SDL_Quit();
        exit(2);
    }

    test( screen );
    SDL_Flip( screen );

    done = 0;
    while ( !done && SDL_WaitEvent( &event ) )
    {
        switch( event.type )
        {
            case SDL_KEYDOWN:
                if ( event.key.keysym.sym == SDLK_ESCAPE )
                    done = 1;
                break;
            case SDL_QUIT:
                done = 1;
                break;
            default:
                break;
        }
    }
    SDL_Quit();
    return 0;
}
*/


/*
int main(int argc, char **argv)
{
    SDL_Surface *pSurface = NULL;
    SDL_Event event;
    int done = 0;

    SDL_Init(SDL_INIT_VIDEO);

    atexit(SDL_Quit);

    pSurface = SDL_SetVideoMode(512, 512, 0, SDL_RESIZABLE);

    while(!done) {
        if (SDL_PollEvent(&event)) {
            switch (event.type) {
                case SDL_VIDEORESIZE:
                    fprintf(stderr, "resized to %dx%d\n", event.resize.w, event.resize.h);
                    pSurface = SDL_SetVideoMode(event.resize.w, event.resize.h, 0, SDL_RESIZABLE);
                    break;
                case SDL_QUIT:
                    done = 1;
                    break;
            }
        }
    }
    return 0;
}
*/

/*
int main(int argc, char **argv)
{
    SDL_Event event;

    SDL_Init(SDL_INIT_VIDEO);
    SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE | SDL_FULLSCREEN);

    while(1) {
        SDL_WaitEvent(&event);
         if (event.type == SDL_KEYDOWN)
            break;
     }

//    SDL_QuitSubSystem(SDL_INIT_VIDEO);
//    SDL_InitSubSystem(SDL_INIT_VIDEO);

    SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE);
    SDL_WM_GrabInput(SDL_GRAB_ON);

    while(1) {
        SDL_WaitEvent(&event);
        if (event.type == SDL_KEYDOWN)
            break;
    }

    SDL_Quit();
    return 0;
}
*/

/*
#include "sdl.h"

int main(int argc, char **argv)
{
    SDL_Event event;

    SDL_Init(SDL_INIT_VIDEO);
    SDL_SetVideoMode(1024, 768, 16, SDL_OPENGL | SDL_FULLSCREEN );

    while(1) {
        SDL_WaitEvent(&event);
        if (event.type == SDL_KEYDOWN)
            break;
    }

    SDL_Quit();
    return 0;
}
*/

/*
#include <stdio.h>
#include <stdlib.h>
#include "SDL.h"
#include "SDL_Image.h"

int main(int argc, char **argv)
{
    SDL_Surface *screen;    // here the display window
    SDL_Surface *test;      // a square
    SDL_Rect    d;          // for square destination position
    SDL_Event   ev;         // for futur events
    Uint32      rmask, gmask, bmask, amask; 

#if SDL_BYTEORDER == SDL_BIG_ENDIAN //setup mask colors
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif


    SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER);

    //initialization
    if(SDL_WasInit(SDL_INIT_VIDEO)!=0)
        printf("** Video init.\n");
    else
        printf("** No video.\n");
    if(SDL_WasInit(SDL_INIT_TIMER)!=0)
        printf("** Time init.\n");
    else
        printf("** No timer.\n");

    //setup surfaces
    screen = SDL_SetVideoMode(800,600,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
    //test = SDL_CreateRGBSurface(SDL_SWSURFACE, 100, 100, 32, rmask, gmask, bmask, amask);
    test = SDL_CreateRGBSurface(SDL_SWSURFACE,100,100,16,
                screen->format->Rmask, screen->format->Gmask,
                screen->format->Bmask, screen->format->Amask);


    d.x = 150; //position where I want to blit the 'test' square into the screen
    d.y = 150;

    while(1) //main loop
    {
        while (SDL_PollEvent(&ev))
        {
            switch(ev.type) //events
            {
                case SDL_QUIT:
                    SDL_Quit(); 
                    printf("** End\n");
                    exit(0);
                    break;
                default:
                    printf("** Unknown Event\n");
            }
        }

        // here we draw all
        SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format,0,0,0)); //to black
        SDL_FillRect(test, NULL, SDL_MapRGBA(test->format,255,255,255,0)); //to white

        SDL_BlitSurface(test,NULL,screen,&d); //blits test into screen
        //some people said that I should put a SOUCE RECTANGLE in second argument, but official
        // SDL documention says that if we pass NULL, whole source Surface is taken for blit.

        SDL_Flip(screen);
    }
}
*/


/*
#include <stdio.h>
#include <stdlib.h>

#include "SDL.h"
#include "SDL_image.h"

#define min(a,b) ((a < b) ? a : b)
#define max(a,b) ((a > b) ? a : b)
#define clamp(lo,value,hi)    (min(max(value,lo),hi))


//inline Uint16 getpixel(SDL_Surface *surface, int x, int y)
//{
//  Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * surface->format->BytesPerPixel;
//  return (*(Uint16 *)p);
//}
//
//inline void putpixel(SDL_Surface *surface, int x, int y, Uint16 color)
//{
//  Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * surface->format->BytesPerPixel;
//  *(Uint16 *)p = color;
//}




//  Reads a single pixel from the surface.
//  No bounds checking.
//  Assumes surface is locked (or doesn't need locking).

Uint32 raw_getpixel(SDL_Surface * surface, int x, int y)
{
    int     bpp = surface->format->BytesPerPixel;
    Uint8   *p = (Uint8*)(((Uint8*)surface->pixels)+(y*surface->pitch)+(x*bpp));
    Uint32  pixel = 0;

    if (bpp == 1)
        pixel = *p;
    else
    if (bpp == 2)
        pixel = *(Uint16 *)p;
    else
    if (bpp == 3)
    {
        if (SDL_BYTEORDER == SDL_BIG_ENDIAN)
            pixel = p[0] << 16 | p[1] << 8 | p[2];
        else
            pixel = p[0] | p[1] << 8 | p[2] << 16;
    }
    else
    if (bpp == 4)
        pixel = *(Uint32 *)p;

    return pixel;
}



//  Draw a single pixel into the surface.
//  No bounds checking.
//  Assumes surface is locked (or doesn't need locking).

void raw_putpixel(SDL_Surface * surface, int x, int y, Uint32 pixel)
{
    int     bpp = surface->format->BytesPerPixel;
    Uint8   *p = (Uint8*)(((Uint8*)surface->pixels)+(y*surface->pitch)+(x*bpp));

    if (bpp == 1)
        *p = pixel;
    else
    if (bpp == 2)
        *(Uint16*)p = pixel;
    else
    if (bpp == 3)
    {
        if (SDL_BYTEORDER == SDL_BIG_ENDIAN)
        {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        }
        else
        {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
    }
    else
    if (bpp == 4)
    {
        *(Uint32*)p = pixel;
    }
}


int main(int argc, char *argv[])
{
    int i, j;
    SDL_Surface *screen, *temp, *sample, *backbuffer;
    SDL_Rect src, dest;

    if (SDL_Init(SDL_INIT_VIDEO) != 0)
    {
        fprintf(stderr, "Could not init SDL: %s\n", SDL_GetError());
        return (-1);
    }

    atexit(SDL_Quit);

    screen = SDL_SetVideoMode(320, 200, 16, SDL_SWSURFACE);
    if (screen == NULL)
    {
        fprintf(stderr, "Could not set video mode.\n");
        return (-1);
    }

    temp = IMG_Load("sample.png");
    if (temp == NULL)
    {
        fprintf(stderr, "Could not load sample.png");
        return (-1);
    }

    printf("[TEMP      ] w=%d, h=%d, bbp=%d\n",temp->w,temp->h,temp->format->BitsPerPixel);

    SDL_SetAlpha(temp,SDL_RLEACCEL,0);
    sample = SDL_DisplayFormatAlpha(temp); 
//  sample = SDL_DisplayFormat(temp); 

    SDL_FreeSurface(temp);

    printf("[SAMPLE    ] w=%d, h=%d, bbp=%d\n",sample->w,sample->h,sample->format->BitsPerPixel);

//  backbuffer = SDL_CreateRGBSurface(SDL_SWSURFACE, sample->w, sample->h,
//                                    sample->format->BitsPerPixel, 
//                                    sample->format->Rmask, sample->format->Gmask, 
//                                    sample->format->Bmask, sample->format->Amask);


    backbuffer = SDL_CreateRGBSurface(SDL_SWSURFACE, sample->w, sample->h,
                                      16, 0x7C00, 0x03E0, 0x001F, 0x8000 );

//  backbuffer = SDL_CreateRGBSurface(SDL_SWSURFACE, sample->w, sample->h,
//                                    screen->format->BitsPerPixel, 
//                                    screen->format->Rmask, screen->format->Gmask, 
//                                    screen->format->Bmask, screen->format->Amask);

    printf("[BACKBUFFER] w=%d, h=%d, bbp=%d\n",backbuffer->w,backbuffer->h,backbuffer->format->BitsPerPixel);

    SDL_LockSurface(sample);
    SDL_LockSurface(backbuffer);
    for (j = 0; j < sample->h; j++)
    {
        for (i = 0; i < sample->w; i++)
        {
            Uint32  pixel;
            Uint8   r,g,b,a;

            SDL_GetRGBA(raw_getpixel(sample, i, j), sample->format, &r, &g, &b, &a);
            pixel = SDL_MapRGBA(backbuffer->format, r, g, b, a);
            raw_putpixel(backbuffer, i, j, pixel);
        }
    }
    SDL_UnlockSurface(backbuffer);
    SDL_UnlockSurface(sample);

    dest.x = 0;
    dest.y = 0;
    dest.w = 320;
    dest.h = 200;
    SDL_FillRect(screen, &dest, SDL_MapRGB(screen->format, 0, 0, 255));

    src.x = 0;
    src.y = 0;
    src.w = backbuffer->w;
    src.h = backbuffer->h;
    dest = src;

    SDL_BlitSurface(backbuffer, &src, screen, &dest);

    SDL_Flip(screen);

    SDL_Delay(5000);

    SDL_FreeSurface(sample);
    SDL_FreeSurface(backbuffer);

    return (0);
}
*/


/*
#include "SDL.h"
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>

int ntex = 1;
static GLuint* texture_ids = NULL;
GLubyte* frame = NULL;

void draw(void)
{
  GLuint i;
  GLenum glerr;
  GLint movie_width=768;
  GLint skip_rows=0;
  GLint skip_pixels=0;

  glLoadIdentity( );
  
  for (i = 0; i < ntex; i++) {
    glBindTexture( GL_TEXTURE_2D, texture_ids[i] );
    glPixelStorei( GL_UNPACK_ROW_LENGTH, movie_width );
    glPixelStorei( GL_UNPACK_SKIP_ROWS, skip_rows );
    glPixelStorei( GL_UNPACK_SKIP_PIXELS, skip_pixels );

    fprintf(stderr,"Now drawing frame\n");

    glerr = glGetError();
    if (glerr != GL_NO_ERROR)
      fprintf(stderr,"GL ERROR: %d  %s\n",glerr, gluErrorString(glerr));
  }
}


int main(int argc, char *argv[])
{
  int i, k;
  GLubyte* pixels;
  SDL_Surface* screen;

  if( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_AUDIO ) < 0 ) {
    fprintf( stderr, "Couldn't initialize SDL\n" );
    return 1;
  }
  screen = SDL_SetVideoMode(1024, 768, 0, SDL_OPENGL);//|SDL_FULLSCREEN);
  if ( !screen ) {
    fprintf( stderr, "Couldn't set 1024x768 GL video mode: %s\n",
SDL_GetError());
    return 1;
  }

  for (k=0; k < 2; k++) {
    glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
    glPixelStorei( GL_UNPACK_ROW_LENGTH, 0 );

    glEnable( GL_TEXTURE_2D );
    glEnable( GL_DITHER );
  
    if (texture_ids)
      free(texture_ids);
    texture_ids = (GLuint*) malloc( sizeof( GLuint ) * ntex );
    if ( !texture_ids ) {
      return 1;
    }

    glGenTextures( ntex, texture_ids );

    for (i=0; i<ntex; i++) {
      fprintf(stderr,"# %d  texture_ids: %d\n",i,texture_ids[i]);
    }
  
    for ( i = 0; i < ntex; i++ ) {
      pixels = (GLubyte*) malloc( 256*256 * 4 );
      memset( pixels, 0, 256*256 * 4 );
      if( !pixels ) {
        glDeleteTextures( ntex, texture_ids );
        return 1;
      }

      glBindTexture( GL_TEXTURE_2D, texture_ids[i] );
      glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
  
      glTexImage2D( GL_TEXTURE_2D,
                    0,
                    3, //GL_RGB,
                    256,
                    256,
                    0,
                    GL_RGBA,
                    GL_UNSIGNED_BYTE,
                    pixels );

      free( pixels );
    }
    draw();
    glDeleteTextures(ntex, texture_ids);
  }
  return 0;
}
*/

/*
#include <stdio.h>
#include "SDL.h"

int main(int argc, char *argv[])
{
    SDL_Surface *screen;

    if (SDL_Init(SDL_INIT_VIDEO) == -1)
    {
        printf("SDL_Init() failed.\n");
        return(42);
    }

    screen = SDL_SetVideoMode(640, 480, 33, 0);
    printf("screen == (%p).\n", screen);
    SDL_Delay(10000);
    SDL_Quit();
    return(0);
}
*/

/*
#include "SDL.h"

int main(int argc, char **argv)
{
    int quit = 0;
    SDL_Init(SDL_INIT_EVERYTHING);
    
    SDL_SetVideoMode(640, 480, 16, SDL_FULLSCREEN);
    while (!quit)
    {
        SDL_Event event;
        
        while (SDL_PollEvent(&event))
        {
            switch (event.type)
            {
                case SDL_MOUSEBUTTONDOWN:
                quit = 1;
            }
        }
    }
    return 0;
}
*/

/*
#include "SDL.h"

int main(int argc, char **argv)
{
    SDL_Init( SDL_INIT_VIDEO|SDL_INIT_NOPARACHUTE );
    atexit( SDL_Quit );

//  SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_FULLSCREEN );
    SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_HWSURFACE | SDL_FULLSCREEN );
//  SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_HWSURFACE );
//  SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_SWSURFACE );
    SDL_Surface* image = SDL_LoadBMP("../boom.bmp");
    SDL_Surface* back  = SDL_LoadBMP("../background.bmp");


    SDL_Surface* imageTile = SDL_DisplayFormat(image);
    SDL_FreeSurface(image);
    SDL_Surface* background = SDL_DisplayFormat(back);
    SDL_FreeSurface(back);
//    SDL_Surface* imageTile = image;
//    SDL_Surface* background = back;

//    Uint32    ck = SDL_MapRGB(imageTile->format, 255, 0, 128);
//    SDL_SetColorKey(imageTile, SDL_SRCCOLORKEY|SDL_RLEACCEL, ck );

    SDL_WM_SetCaption("SDL test program", NULL);
    SDL_BlitSurface(background, NULL, screen, NULL);
    SDL_Flip(screen);

    SDL_Event event;

    for (;;) 
    {
        if ( SDL_PollEvent ( &event ) ) 
        {
            if (event.type == SDL_KEYDOWN) break;
            else
            if ( event.type == SDL_QUIT ) break;
            else
            if ( event.type == SDL_MOUSEBUTTONDOWN)
            {
                if ( event.button.button == SDL_BUTTON_LEFT )
                {
                    SDL_Rect target;

                    target.x = event.button.x - 10;
                    target.y = event.button.y - 10;
                    SDL_BlitSurface(imageTile, NULL, screen, &target);
                    SDL_Flip(screen);
                }
                else
                if ( event.button.button == SDL_BUTTON_RIGHT )
                {
                    SDL_Rect target;

                    target.x = event.button.x - 10;
                    target.y = event.button.y - 10;
                    target.w = imageTile->w;
                    target.h = imageTile->h;
                    SDL_BlitSurface(screen, &target, imageTile, NULL);
                }
            }
        }
    }
    return 0;
}
*/

/*
#include <stdlib.h>
#include "SDL.h"


SDL_Surface *display = NULL;
SDL_Surface *s1 = NULL;
SDL_Surface *s2 = NULL;


int m_isRLE(SDL_Surface *srf)
{
    return ((srf->flags & SDL_RLEACCEL) == SDL_RLEACCEL);
}

int loadImages()
{
    int       s1r, s2r;
    SDL_Rect  rc = { 80,20,20,10 };

    s1 = SDL_CreateRGBSurface(SDL_SWSURFACE, 57, 18, 32, 
                              0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);
    if (!s1) return 0;
    SDL_FillRect( s1, NULL, SDL_MapRGB(s1->format, 221, 255, 221) );

    if ( SDL_SetAlpha(s1, SDL_SRCALPHA | SDL_RLEACCEL, 255) )
        return 0;

    s2 = SDL_CreateRGBSurface(SDL_SWSURFACE, 180, 50, 32, 
                              0x00FF0000, 0x0000FF00, 0x000000FF, 0x00000000);
    if (!s2) return 0;
    SDL_FillRect( s2, NULL, SDL_MapRGB(s2->format, 0, 0, 0) );
    SDL_FillRect( s2, &rc, SDL_MapRGB(s2->format, 63, 73, 83) );

    SDL_SetColorKey(s2, SDL_SRCCOLORKEY | SDL_RLEACCEL, 
                    SDL_MapRGB(s2->format, 0, 0, 0));

    if ( SDL_BlitSurface(s1, NULL, s2, NULL) )
        return 0;

    if ( SDL_BlitSurface(s2, NULL, display, NULL) )
        return 0;

    s1r = m_isRLE(s1);
    s2r = m_isRLE(s2);

    // !!! HERE COMES THE EXCEPTION !!!
    if ( SDL_BlitSurface(s1, NULL, s2, NULL) )
        return 0;
    // !!! HERE COMES THE EXCEPTION !!!

    SDL_UpdateRect(display, 0, 0, 0, 0);
    
    return 1;
}


int main(int argc, char **argv)
{
    SDL_Event   event;

    if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_NOPARACHUTE) < 0) {
        fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError());
        exit(0);
    }
    atexit(SDL_Quit);

    display = SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE);
    if (!display) {
        fprintf(stderr, "Couldn't set video mode 640x480, 32bpp: %s\n", SDL_GetError());
        return 0;
    }
    SDL_FillRect(display, NULL, SDL_MapRGB(display->format, 0, 0, 0));
    SDL_UpdateRect(display, 0, 0, 0, 0);

    if ( !loadImages() ) exit(0);

    while ( SDL_WaitEvent( &event ) ) {
        if ( event.type == SDL_KEYDOWN ) break;
        if ( event.type == SDL_QUIT ) break;
    }

    return 0;
}
*/

/*
#include <stdlib.h>
#include "SDL.h"

int main(int argc, char **argv)
{
    SDL_Surface     *surf;
    
    surf = SDL_CreateRGBSurface(SDL_SWSURFACE, 57, 18, 32, 
                                0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);

    SDL_FreeSurface(surf);

    return 0;
}
*/

/*
#include <SDL.h>
//#include <SDL_events.h>

int main(int argc, char **argv)
{
	SDL_Event event;
	SDL_Surface *screen;

	SDL_Init(SDL_INIT_EVERYTHING);
	screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE);
	SDL_LockSurface(screen);

	for (;;) {
		SDL_WaitEvent(&event);
		if (event.type == SDL_MOUSEBUTTONDOWN)
			exit(0);
	}
}
*/

#include <stdio.h>
#include <stdlib.h>

#include "SDL.h"

// The functions are not shown to save space
void DrawPixel(SDL_Surface *screen, int x, int y,
                                    Uint8 R, Uint8 G, Uint8 B);
void Slock(SDL_Surface *screen);
void Sulock(SDL_Surface *screen);

void Slock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) )
  {
    if ( SDL_LockSurface(screen) < 0 )
    {
      return;
    }
  }
}

void Sulock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) )
  {
    SDL_UnlockSurface(screen);
  }
}

int main(int argc, char *argv[])
{

  if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 )
  {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);

  SDL_Surface *screen;

  screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
  if ( screen == NULL )
  {
    printf("Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
  }

  // DRAWING GOES HERE
  Slock(screen);
  for(int x=0;x<640;x++)
  {
 for(int y=0;y<480;y++)
 {
  DrawPixel(screen, x,y,y/2,y/2,x/3);
 }
  }
  Sulock(screen);
  SDL_Flip(screen);

  return 0;
}

