/*
#include "sdl.h"
#include "sdl_image.h"
#include "assert.h"
#include "stdlib.h"
#include "stdarg.h"

extern "C" {
    void __stdcall OutputDebugStringA( const char * );
};

void Printf( const char *fmt,... )
{
    char    Buff[100];
    va_list marker;
    
    va_start( marker,fmt );
    vsprintf( Buff,fmt,marker );
    va_end( marker );
    OutputDebugStringA( Buff );
}



void test( SDL_Surface *screen )
{
    SDL_Surface *intro, *temp;

    temp = IMG_Load("pngbar.png");
    assert(temp);

    intro = SDL_DisplayFormat(temp);
    assert(intro);
    SDL_FreeSurface(temp);

    SDL_SetAlpha(intro, SDL_SRCALPHA, 128);
    SDL_BlitSurface(intro, NULL, screen, NULL);
    SDL_FreeSurface(intro);
}


int main( int argc, char *argv[] )
{
    SDL_Surface *screen;
    int         width, height, bpp;
    Uint32      videoflags;
    SDL_Event   event;
    int         done;

    width = 640; height = 480; bpp = 16;
    videoflags = SDL_SWSURFACE;
    videoflags = SDL_DOUBLEBUF|SDL_HWSURFACE;
    //videoflags |= SDL_FULLSCREEN;

    if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
    {
        fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
        exit(1);
    }

    screen = SDL_SetVideoMode( width, height, bpp, videoflags );
    if ( screen == NULL )
    {
        fprintf( stderr, "Couldn't set display mode: %s\n", SDL_GetError() );
        SDL_Quit();
        exit(2);
    }

    test( screen );
    SDL_Flip( screen );

    done = 0;
    while ( !done && SDL_WaitEvent( &event ) )
    {
        switch( event.type )
        {
            case SDL_KEYDOWN:
                if ( event.key.keysym.sym == SDLK_ESCAPE )
                    done = 1;
                break;
            case SDL_QUIT:
                done = 1;
                break;
            default:
                break;
        }
    }
    SDL_Quit();
    return 0;
}
*/


/*
int main(int argc, char **argv)
{
    SDL_Surface *pSurface = NULL;
    SDL_Event event;
    int done = 0;

    SDL_Init(SDL_INIT_VIDEO);

    atexit(SDL_Quit);

    pSurface = SDL_SetVideoMode(512, 512, 0, SDL_RESIZABLE);

    while(!done) {
        if (SDL_PollEvent(&event)) {
            switch (event.type) {
                case SDL_VIDEORESIZE:
                    fprintf(stderr, "resized to %dx%d\n", event.resize.w, event.resize.h);
                    pSurface = SDL_SetVideoMode(event.resize.w, event.resize.h, 0, SDL_RESIZABLE);
                    break;
                case SDL_QUIT:
                    done = 1;
                    break;
            }
        }
    }
    return 0;
}
*/

/*
int main(int argc, char **argv)
{
    SDL_Event event;

    SDL_Init(SDL_INIT_VIDEO);
    SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE | SDL_FULLSCREEN);

    while(1) {
        SDL_WaitEvent(&event);
         if (event.type == SDL_KEYDOWN)
            break;
     }

//    SDL_QuitSubSystem(SDL_INIT_VIDEO);
//    SDL_InitSubSystem(SDL_INIT_VIDEO);

    SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE);
    SDL_WM_GrabInput(SDL_GRAB_ON);

    while(1) {
        SDL_WaitEvent(&event);
        if (event.type == SDL_KEYDOWN)
            break;
    }

    SDL_Quit();
    return 0;
}
*/

/*
#include "sdl.h"

int main(int argc, char **argv)
{
    SDL_Event event;

    SDL_Init(SDL_INIT_VIDEO);
    SDL_SetVideoMode(1024, 768, 16, SDL_OPENGL | SDL_FULLSCREEN );

    while(1) {
        SDL_WaitEvent(&event);
        if (event.type == SDL_KEYDOWN)
            break;
    }

    SDL_Quit();
    return 0;
}
*/

/*
#include <stdio.h>
#include <stdlib.h>
#include "SDL.h"
#include "SDL_Image.h"

int main(int argc, char **argv)
{
    SDL_Surface *screen;    // here the display window
    SDL_Surface *test;      // a square
    SDL_Rect    d;          // for square destination position
    SDL_Event   ev;         // for futur events
    Uint32      rmask, gmask, bmask, amask; 

#if SDL_BYTEORDER == SDL_BIG_ENDIAN //setup mask colors
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif


    SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER);

    //initialization
    if(SDL_WasInit(SDL_INIT_VIDEO)!=0)
        printf("** Video init.\n");
    else
        printf("** No video.\n");
    if(SDL_WasInit(SDL_INIT_TIMER)!=0)
        printf("** Time init.\n");
    else
        printf("** No timer.\n");

    //setup surfaces
    screen = SDL_SetVideoMode(800,600,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
    //test = SDL_CreateRGBSurface(SDL_SWSURFACE, 100, 100, 32, rmask, gmask, bmask, amask);
    test = SDL_CreateRGBSurface(SDL_SWSURFACE,100,100,16,
                screen->format->Rmask, screen->format->Gmask,
                screen->format->Bmask, screen->format->Amask);


    d.x = 150; //position where I want to blit the 'test' square into the screen
    d.y = 150;

    while(1) //main loop
    {
        while (SDL_PollEvent(&ev))
        {
            switch(ev.type) //events
            {
                case SDL_QUIT:
                    SDL_Quit(); 
                    printf("** End\n");
                    exit(0);
                    break;
                default:
                    printf("** Unknown Event\n");
            }
        }

        // here we draw all
        SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format,0,0,0)); //to black
        SDL_FillRect(test, NULL, SDL_MapRGBA(test->format,255,255,255,0)); //to white

        SDL_BlitSurface(test,NULL,screen,&d); //blits test into screen
        //some people said that I should put a SOUCE RECTANGLE in second argument, but official
        // SDL documention says that if we pass NULL, whole source Surface is taken for blit.

        SDL_Flip(screen);
    }
}
*/


/*
#include <stdio.h>
#include <stdlib.h>

#include "SDL.h"
#include "SDL_image.h"

#define min(a,b) ((a < b) ? a : b)
#define max(a,b) ((a > b) ? a : b)
#define clamp(lo,value,hi)    (min(max(value,lo),hi))


//inline Uint16 getpixel(SDL_Surface *surface, int x, int y)
//{
//  Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * surface->format->BytesPerPixel;
//  return (*(Uint16 *)p);
//}
//
//inline void putpixel(SDL_Surface *surface, int x, int y, Uint16 color)
//{
//  Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * surface->format->BytesPerPixel;
//  *(Uint16 *)p = color;
//}




//  Reads a single pixel from the surface.
//  No bounds checking.
//  Assumes surface is locked (or doesn't need locking).

Uint32 raw_getpixel(SDL_Surface * surface, int x, int y)
{
    int     bpp = surface->format->BytesPerPixel;
    Uint8   *p = (Uint8*)(((Uint8*)surface->pixels)+(y*surface->pitch)+(x*bpp));
    Uint32  pixel = 0;

    if (bpp == 1)
        pixel = *p;
    else
    if (bpp == 2)
        pixel = *(Uint16 *)p;
    else
    if (bpp == 3)
    {
        if (SDL_BYTEORDER == SDL_BIG_ENDIAN)
            pixel = p[0] << 16 | p[1] << 8 | p[2];
        else
            pixel = p[0] | p[1] << 8 | p[2] << 16;
    }
    else
    if (bpp == 4)
        pixel = *(Uint32 *)p;

    return pixel;
}



//  Draw a single pixel into the surface.
//  No bounds checking.
//  Assumes surface is locked (or doesn't need locking).

void raw_putpixel(SDL_Surface * surface, int x, int y, Uint32 pixel)
{
    int     bpp = surface->format->BytesPerPixel;
    Uint8   *p = (Uint8*)(((Uint8*)surface->pixels)+(y*surface->pitch)+(x*bpp));

    if (bpp == 1)
        *p = pixel;
    else
    if (bpp == 2)
        *(Uint16*)p = pixel;
    else
    if (bpp == 3)
    {
        if (SDL_BYTEORDER == SDL_BIG_ENDIAN)
        {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        }
        else
        {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
    }
    else
    if (bpp == 4)
    {
        *(Uint32*)p = pixel;
    }
}


int main(int argc, char *argv[])
{
    int i, j;
    SDL_Surface *screen, *temp, *sample, *backbuffer;
    SDL_Rect src, dest;

    if (SDL_Init(SDL_INIT_VIDEO) != 0)
    {
        fprintf(stderr, "Could not init SDL: %s\n", SDL_GetError());
        return (-1);
    }

    atexit(SDL_Quit);

    screen = SDL_SetVideoMode(320, 200, 16, SDL_SWSURFACE);
    if (screen == NULL)
    {
        fprintf(stderr, "Could not set video mode.\n");
        return (-1);
    }

    temp = IMG_Load("sample.png");
    if (temp == NULL)
    {
        fprintf(stderr, "Could not load sample.png");
        return (-1);
    }

    printf("[TEMP      ] w=%d, h=%d, bbp=%d\n",temp->w,temp->h,temp->format->BitsPerPixel);

    SDL_SetAlpha(temp,SDL_RLEACCEL,0);
    sample = SDL_DisplayFormatAlpha(temp); 
//  sample = SDL_DisplayFormat(temp); 

    SDL_FreeSurface(temp);

    printf("[SAMPLE    ] w=%d, h=%d, bbp=%d\n",sample->w,sample->h,sample->format->BitsPerPixel);

//  backbuffer = SDL_CreateRGBSurface(SDL_SWSURFACE, sample->w, sample->h,
//                                    sample->format->BitsPerPixel, 
//                                    sample->format->Rmask, sample->format->Gmask, 
//                                    sample->format->Bmask, sample->format->Amask);


    backbuffer = SDL_CreateRGBSurface(SDL_SWSURFACE, sample->w, sample->h,
                                      16, 0x7C00, 0x03E0, 0x001F, 0x8000 );

//  backbuffer = SDL_CreateRGBSurface(SDL_SWSURFACE, sample->w, sample->h,
//                                    screen->format->BitsPerPixel, 
//                                    screen->format->Rmask, screen->format->Gmask, 
//                                    screen->format->Bmask, screen->format->Amask);

    printf("[BACKBUFFER] w=%d, h=%d, bbp=%d\n",backbuffer->w,backbuffer->h,backbuffer->format->BitsPerPixel);

    SDL_LockSurface(sample);
    SDL_LockSurface(backbuffer);
    for (j = 0; j < sample->h; j++)
    {
        for (i = 0; i < sample->w; i++)
        {
            Uint32  pixel;
            Uint8   r,g,b,a;

            SDL_GetRGBA(raw_getpixel(sample, i, j), sample->format, &r, &g, &b, &a);
            pixel = SDL_MapRGBA(backbuffer->format, r, g, b, a);
            raw_putpixel(backbuffer, i, j, pixel);
        }
    }
    SDL_UnlockSurface(backbuffer);
    SDL_UnlockSurface(sample);

    dest.x = 0;
    dest.y = 0;
    dest.w = 320;
    dest.h = 200;
    SDL_FillRect(screen, &dest, SDL_MapRGB(screen->format, 0, 0, 255));

    src.x = 0;
    src.y = 0;
    src.w = backbuffer->w;
    src.h = backbuffer->h;
    dest = src;

    SDL_BlitSurface(backbuffer, &src, screen, &dest);

    SDL_Flip(screen);

    SDL_Delay(5000);

    SDL_FreeSurface(sample);
    SDL_FreeSurface(backbuffer);

    return (0);
}
*/


/*
#include "SDL.h"
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>

int ntex = 1;
static GLuint* texture_ids = NULL;
GLubyte* frame = NULL;

void draw(void)
{
  GLuint i;
  GLenum glerr;
  GLint movie_width=768;
  GLint skip_rows=0;
  GLint skip_pixels=0;

  glLoadIdentity( );
  
  for (i = 0; i < ntex; i++) {
    glBindTexture( GL_TEXTURE_2D, texture_ids[i] );
    glPixelStorei( GL_UNPACK_ROW_LENGTH, movie_width );
    glPixelStorei( GL_UNPACK_SKIP_ROWS, skip_rows );
    glPixelStorei( GL_UNPACK_SKIP_PIXELS, skip_pixels );

    fprintf(stderr,"Now drawing frame\n");

    glerr = glGetError();
    if (glerr != GL_NO_ERROR)
      fprintf(stderr,"GL ERROR: %d  %s\n",glerr, gluErrorString(glerr));
  }
}


int main(int argc, char *argv[])
{
  int i, k;
  GLubyte* pixels;
  SDL_Surface* screen;

  if( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_AUDIO ) < 0 ) {
    fprintf( stderr, "Couldn't initialize SDL\n" );
    return 1;
  }
  screen = SDL_SetVideoMode(1024, 768, 0, SDL_OPENGL);//|SDL_FULLSCREEN);
  if ( !screen ) {
    fprintf( stderr, "Couldn't set 1024x768 GL video mode: %s\n",
SDL_GetError());
    return 1;
  }

  for (k=0; k < 2; k++) {
    glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
    glPixelStorei( GL_UNPACK_ROW_LENGTH, 0 );

    glEnable( GL_TEXTURE_2D );
    glEnable( GL_DITHER );
  
    if (texture_ids)
      free(texture_ids);
    texture_ids = (GLuint*) malloc( sizeof( GLuint ) * ntex );
    if ( !texture_ids ) {
      return 1;
    }

    glGenTextures( ntex, texture_ids );

    for (i=0; i<ntex; i++) {
      fprintf(stderr,"# %d  texture_ids: %d\n",i,texture_ids[i]);
    }
  
    for ( i = 0; i < ntex; i++ ) {
      pixels = (GLubyte*) malloc( 256*256 * 4 );
      memset( pixels, 0, 256*256 * 4 );
      if( !pixels ) {
        glDeleteTextures( ntex, texture_ids );
        return 1;
      }

      glBindTexture( GL_TEXTURE_2D, texture_ids[i] );
      glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
      glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
  
      glTexImage2D( GL_TEXTURE_2D,
                    0,
                    3, //GL_RGB,
                    256,
                    256,
                    0,
                    GL_RGBA,
                    GL_UNSIGNED_BYTE,
                    pixels );

      free( pixels );
    }
    draw();
    glDeleteTextures(ntex, texture_ids);
  }
  return 0;
}
*/

/*
#include <stdio.h>
#include "SDL.h"

int main(int argc, char *argv[])
{
    SDL_Surface *screen;

    if (SDL_Init(SDL_INIT_VIDEO) == -1)
    {
        printf("SDL_Init() failed.\n");
        return(42);
    }

    screen = SDL_SetVideoMode(640, 480, 33, 0);
    printf("screen == (%p).\n", screen);
    SDL_Delay(10000);
    SDL_Quit();
    return(0);
}
*/

/*
#include "SDL.h"

int main(int argc, char **argv)
{
    int quit = 0;
    SDL_Init(SDL_INIT_EVERYTHING);
    
    SDL_SetVideoMode(640, 480, 16, SDL_FULLSCREEN);
    while (!quit)
    {
        SDL_Event event;
        
        while (SDL_PollEvent(&event))
        {
            switch (event.type)
            {
                case SDL_MOUSEBUTTONDOWN:
                quit = 1;
            }
        }
    }
    return 0;
}
*/

/*
#include "SDL.h"

int main(int argc, char **argv)
{
    SDL_Init( SDL_INIT_VIDEO|SDL_INIT_NOPARACHUTE );
    atexit( SDL_Quit );

//  SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_FULLSCREEN );
    SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_HWSURFACE | SDL_FULLSCREEN );
//  SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_HWSURFACE );
//  SDL_Surface* screen = SDL_SetVideoMode ( 800 , 600, 0, SDL_SWSURFACE );
    SDL_Surface* image = SDL_LoadBMP("../boom.bmp");
    SDL_Surface* back  = SDL_LoadBMP("../background.bmp");


    SDL_Surface* imageTile = SDL_DisplayFormat(image);
    SDL_FreeSurface(image);
    SDL_Surface* background = SDL_DisplayFormat(back);
    SDL_FreeSurface(back);
//    SDL_Surface* imageTile = image;
//    SDL_Surface* background = back;

//    Uint32    ck = SDL_MapRGB(imageTile->format, 255, 0, 128);
//    SDL_SetColorKey(imageTile, SDL_SRCCOLORKEY|SDL_RLEACCEL, ck );

    SDL_WM_SetCaption("SDL test program", NULL);
    SDL_BlitSurface(background, NULL, screen, NULL);
    SDL_Flip(screen);

    SDL_Event event;

    for (;;) 
    {
        if ( SDL_PollEvent ( &event ) ) 
        {
            if (event.type == SDL_KEYDOWN) break;
            else
            if ( event.type == SDL_QUIT ) break;
            else
            if ( event.type == SDL_MOUSEBUTTONDOWN)
            {
                if ( event.button.button == SDL_BUTTON_LEFT )
                {
                    SDL_Rect target;

                    target.x = event.button.x - 10;
                    target.y = event.button.y - 10;
                    SDL_BlitSurface(imageTile, NULL, screen, &target);
                    SDL_Flip(screen);
                }
                else
                if ( event.button.button == SDL_BUTTON_RIGHT )
                {
                    SDL_Rect target;

                    target.x = event.button.x - 10;
                    target.y = event.button.y - 10;
                    target.w = imageTile->w;
                    target.h = imageTile->h;
                    SDL_BlitSurface(screen, &target, imageTile, NULL);
                }
            }
        }
    }
    return 0;
}
*/

/*
#include <stdlib.h>
#include "SDL.h"


SDL_Surface *display = NULL;
SDL_Surface *s1 = NULL;
SDL_Surface *s2 = NULL;


int m_isRLE(SDL_Surface *srf)
{
    return ((srf->flags & SDL_RLEACCEL) == SDL_RLEACCEL);
}

int loadImages()
{
    int       s1r, s2r;
    SDL_Rect  rc = { 80,20,20,10 };

    s1 = SDL_CreateRGBSurface(SDL_SWSURFACE, 57, 18, 32, 
                              0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);
    if (!s1) return 0;
    SDL_FillRect( s1, NULL, SDL_MapRGB(s1->format, 221, 255, 221) );

    if ( SDL_SetAlpha(s1, SDL_SRCALPHA | SDL_RLEACCEL, 255) )
        return 0;

    s2 = SDL_CreateRGBSurface(SDL_SWSURFACE, 180, 50, 32, 
                              0x00FF0000, 0x0000FF00, 0x000000FF, 0x00000000);
    if (!s2) return 0;
    SDL_FillRect( s2, NULL, SDL_MapRGB(s2->format, 0, 0, 0) );
    SDL_FillRect( s2, &rc, SDL_MapRGB(s2->format, 63, 73, 83) );

    SDL_SetColorKey(s2, SDL_SRCCOLORKEY | SDL_RLEACCEL, 
                    SDL_MapRGB(s2->format, 0, 0, 0));

    if ( SDL_BlitSurface(s1, NULL, s2, NULL) )
        return 0;

    if ( SDL_BlitSurface(s2, NULL, display, NULL) )
        return 0;

    s1r = m_isRLE(s1);
    s2r = m_isRLE(s2);

    // !!! HERE COMES THE EXCEPTION !!!
    if ( SDL_BlitSurface(s1, NULL, s2, NULL) )
        return 0;
    // !!! HERE COMES THE EXCEPTION !!!

    SDL_Flip(display);
    
    return 1;
}


int main(int argc, char **argv)
{
    SDL_Event   event;

    if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_NOPARACHUTE) < 0) {
        fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError());
        exit(0);
    }
    atexit(SDL_Quit);

    display = SDL_SetVideoMode(640, 480, 32, SDL_HWPALETTE|SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
    if (!display) {
        fprintf(stderr, "Couldn't set video mode 640x480, 32bpp: %s\n", SDL_GetError());
        return 0;
    }
    SDL_FillRect(display, NULL, SDL_MapRGB(display->format, 0, 0, 0));
    SDL_Flip(display);

    if ( !loadImages() ) exit(0);

    while ( SDL_WaitEvent( &event ) ) {
        if ( event.type == SDL_KEYDOWN ) break;
        if ( event.type == SDL_QUIT ) break;
    }

    return 0;
}
*/

/*
#include <stdlib.h>
#include "SDL.h"

int main(int argc, char **argv)
{
    SDL_Surface     *surf;
    
    surf = SDL_CreateRGBSurface(SDL_SWSURFACE, 57, 18, 32, 
                                0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);

    SDL_FreeSurface(surf);

    return 0;
}
*/

/*
#include <stdlib.h>
#include <SDL.h>
//#include <SDL_events.h>

int main(int argc, char **argv)
{
	SDL_Event event;
	SDL_Surface *screen;

	SDL_Init(SDL_INIT_EVERYTHING);
	screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE);
	SDL_LockSurface(screen);

	Uint8 *keystate = SDL_GetKeyState(NULL);

	for (;;) {
		SDL_WaitEvent(&event);
		if (event.type == SDL_MOUSEBUTTONDOWN)
			exit(0);

		if ( keystate[SDLK_SPACE] ) printf("[space]\n");
		if ( keystate[SDLK_PAUSE] ) printf("[pause]\n");
	}
}
*/

/*
#include <stdio.h>
#include <stdlib.h>

#include "SDL.h"

// The functions are not shown to save space
void DrawPixel(SDL_Surface *screen, int x, int y,
                                    Uint8 R, Uint8 G, Uint8 B);
void Slock(SDL_Surface *screen);
void Sulock(SDL_Surface *screen);

void Slock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) )
  {
    if ( SDL_LockSurface(screen) < 0 )
    {
      return;
    }
  }
}

void Sulock(SDL_Surface *screen)
{
  if ( SDL_MUSTLOCK(screen) )
  {
    SDL_UnlockSurface(screen);
  }
}

int main(int argc, char *argv[])
{

  if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 )
  {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);

  SDL_Surface *screen;

  screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
  if ( screen == NULL )
  {
    printf("Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
  }

  // DRAWING GOES HERE
  Slock(screen);
  for(int x=0;x<640;x++)
  {
 for(int y=0;y<480;y++)
 {
  DrawPixel(screen, x,y,y/2,y/2,x/3);
 }
  }
  Sulock(screen);
  SDL_Flip(screen);

  return 0;
}
*/

/*
#include <stdio.h>
#include <stdlib.h>
#include "SDL.h"

#define DISPLAY_RES_X 320
#define DISPLAY_RES_Y 240

int main(int argc, char *argv[])
{
  SDL_Surface *screen;
  SDL_Color colour[1];
  SDL_Event keyboard_check;
  SDL_PixelFormat *colour_format;
  
  
  printf(" SDL.\n");
  
  if( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError());
    exit(1);
  }	
  
  if(SDL_VideoModeOK(DISPLAY_RES_X, DISPLAY_RES_Y, 32, SDL_FULLSCREEN | SDL_HWSURFACE | SDL_DOUBLEBUF) != 32)
  {
    fprintf(stderr, "video mode not possible on this hardware\n");
    exit(1);
  }
  
  
  screen = SDL_SetVideoMode(DISPLAY_RES_X, DISPLAY_RES_Y, 32, SDL_FULLSCREEN | SDL_HWSURFACE | SDL_DOUBLEBUF);
  if ( screen == NULL ) {
    fprintf(stderr, "Couldn't set %ix%ix32 video mode: %s\n", DISPLAY_RES_X, DISPLAY_RES_Y, SDL_GetError());
    exit(1);
  }
  
  colour[0].r = 0;
  colour[0].g = 0;
  colour[0].b = 0;
  
  colour_format=screen->format;
  
  int	done = 0;

  while(!done)
  {
    while(SDL_PollEvent(&keyboard_check))
	{
      switch(keyboard_check.type) {
		case SDL_KEYDOWN:
			done = 1;
			break;
      }
    }
    
    colour[0].r = (int)(rand() % 255);
    colour[0].g = (int)(rand() % 255);
    colour[0].b = (int)(rand() % 255);
    SDL_FillRect(screen, 0, SDL_MapRGB(colour_format, colour[0].r, colour[0].g, colour[0].b));
    
    // Update the screen
    SDL_Flip(screen);
    
  }	
  
  printf("Quiting SDL.\n");
  SDL_Quit();

  return 0;
}
*/

/*
#include <iostream.h>
#include "SDL.h"
#include "SDL_mixer.h"
#include <stdlib.h>

Uint32 timer_callback(Uint32 interval, void *p)
{
  Mix_Chunk *chnk_obj = (Mix_Chunk *) p;

  cout << "Num of allocated channels is : " << Mix_AllocateChannels(-1) << endl;

  if(Mix_PlayChannel(3,chnk_obj,0) == -1) //channel 2 dont work
     cout << "ERROR: Couldnt play wav" << endl;
  return interval;
}


int main(int argc, char **argv)
{
  Mix_Chunk *chunk;
  SDL_TimerID id;

  if(SDL_Init(SDL_INIT_AUDIO | SDL_INIT_TIMER | SDL_INIT_NOPARACHUTE) == -1) {
    cout << "ERROR: Couldnt initialize sub-systems" << endl;
    exit(-1);
  }
  cout << "Sub-systems intialized successfully....." << endl;

  int freq = 44100;
  Uint16 fmt = AUDIO_S16;
  int channels = 2;
  int chnk_size = 1024;

  if(Mix_OpenAudio(freq, fmt, channels, chnk_size)) {
    cout << "ERROR: Unable to open audio device" << endl;
    exit(-1);
  }
  cout << "Audio device opened succesfully......" << endl;

  Mix_AllocateChannels(5); //using 5 independent channels for testing purposes
  if((chunk = Mix_LoadWAV("../sample.wav")) == NULL) {
    cout << "ERROR: Couldnt load wav" << endl;
    exit(-1);
  }

  cout << "Playing wav file........."  << endl;
  id = SDL_AddTimer(300, timer_callback, chunk);
  SDL_Delay(3 * 1000);

  return 0;
}
*/

/*
#include <stdlib.h>
#include "SDL.h"
#include "SDL_ttf.h"

int main( int argc, char *argv[] )
{
	SDL_Event ev;
	SDL_Surface *screen; //display
	SDL_Surface *tmp; //font surface
	SDL_Rect x; //location to display font
	SDL_Color fg; //font fgcolor
	TTF_Font *font; //font

	//init stuff
//    if ( SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_EVENTTHREAD) < 0 )
    if ( SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO|SDL_INIT_AUDIO) < 0 )
    {
        fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
        exit(1);
    }

	screen = SDL_SetVideoMode(800, 600, 32, SDL_HWSURFACE|SDL_DOUBLEBUF);

	TTF_Init();

	//load font, no problem here
	if((font=TTF_OpenFont("./comic.ttf", 32))==NULL) //file is ok
		printf("** font load error\n");
	else
		printf("** font load OK\n");

	//set up font fgcolor
	fg.r = 255;
	fg.g = 0;
	fg.b = 0;

	//set up position
	x.x = 100;
	x.y = 100;

	//clear screen
	SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format,0,0,0));

	//create font surface - here problem, tmp surface stays NULL
	if((tmp=TTF_RenderText_Solid(font, "tralalal", fg))==NULL)
		printf("** font draw error\n");
	else
		printf("** font draw OK\n");

	while(1)
	{
		while(SDL_PollEvent(&ev))
		{
			switch(ev.type)
			{
				case SDL_KEYDOWN:
					return 0;
					break;

				case SDL_QUIT:
					return 0;
			}
		}

		SDL_BlitSurface(tmp, NULL, screen, &x);
		SDL_Flip(screen);
	}

	TTF_CloseFont(font);
	return 0;
}
*/


/*
#pragma warning( push, 3 )
#include <iostream>
#pragma warning( pop ) 
#include "SDL.h"
using namespace std;
#pragma warning( disable : 4514)

// ------------------------- GLOBAL VARIABLES (BEFORE CLASSES)

SDL_Surface *screen, *back;


// ------------------------- NON-CLASS FUNCTIONS

SDL_Surface * ImageLoad(char *file)
{
    SDL_Surface *tmp1, *tmp2 = NULL;

    tmp1 = SDL_LoadBMP(file);
    if ( tmp1 )
	{
		tmp2 = SDL_DisplayFormat(tmp1);
		SDL_FreeSurface(tmp1);
	}
    return tmp2;
}

int LoadBG()
{
    if ( (back = ImageLoad("data/bg.gmp")) == NULL )
		return -1;
    return 0;
}

void DrawIMG(SDL_Surface *img, int x, int y)
{
    SDL_Rect dest;
    dest.x = x;
    dest.y = y;

    SDL_BlitSurface(img, NULL, screen, &dest);
}

void DrawBG()
{
    DrawIMG(back, 0, 0);
}
// -------------------------END OF NON-CLASS FUNCTIONS

// -------------------------CLASESSES
struct CSpriteFrame   // Class - Helper
{
    SDL_Surface *frame_img; // A FRAME IMAGE
    int pause;
};

class CSpriteBase
{
public:
    int init(char *dir);
    CSpriteFrame *sAnim;

    int mNumframes, mBuilt, mW, mH;
};


class CSprite
{
	int mFrame;
	int mX, mY, mOldX, mOldY;
	int mAnimating;
	int mDrawn;
	float mSpeed;
	long mLastupdate;
	CSpriteBase *mSpriteBase;
	SDL_Surface *mBackreplacement;
	SDL_Surface *mScreen;

public:
	// CSprite CLASS-FUNCTIONS Declaration.

	int init(CSpriteBase *base, SDL_Surface *screen); // inicializacion del objecto.
	void draw();         // Dibujar objeto en supersficie.
	void ClearBG();      // Limpiar el fondo del sprite.
	void UpdateBG();     // Actualizar el FONDO del sprite.

	// Currently displaying frame CONTROL

	void setFrame(int fn) { mFrame = fn; }
	int getFrame() { return mFrame; }

	// SPEED Control

	void setSpeed(float sn) { mSpeed = sn; }
	float getSpeed() { return mSpeed; }

	// ANIMATION Control

	void TogAnim() { mAnimating = !mAnimating; }
	void startAnim() { mAnimating = 1; }
	void stopAnim() { mAnimating = 0; }
	void rewind() { mFrame = 0; }

	// SCREEN Positioning of Sprites CONTROL

	void xadd(int nm) { mX+=nm; }
	void yadd(int nm) { mY+=nm; }
	void xset(int nm) { mX=nm; }
	void yset(int nm) { mY=nm; }
	void set(int nx, int ny) { mX = nx; mY = ny; }

};



// ------------------------- CLASS FUNCTIONS

// Function "init" of class CSpriteBase.
int CSpriteBase::init(char *dir)
{
	char buffer[255];   // Buffer para guardar lineas del archivo de datos
	char filename[50];  // Archivo de datos
	char name_bmp[15];  // Archivo BMP de la frame
	int pause=0,r=0,g=0,b=0;
	FILE *fp;

	sprintf(filename, "%s/info", dir);

	if ((fp=fopen(filename, "r")) == NULL)
	{
		cout <<"Error abriendo archivo de datos: %s" << filename << endl;
		return -1;
	}

	// Tomamos la primer linea, asi sabemos la cantidad de FRAMES de esta animacion

	fgets(buffer,255,fp);
	sscanf(buffer, "FILES: %d", &mNumframes);

	sAnim = new CSpriteFrame[mNumframes]; // Hacemos espacio para el sAnim de este sprite.

	mBuilt = 1;
	int count = 0;

	while (!feof(fp) && count < mNumframes)
	{
		fgets(buffer, 255, fp);

		if (buffer[0] != '#' && buffer[0] != '\r' && buffer[0] != '\n' && buffer[0] != 0 && buffer[0] != '\0')
		{
			sscanf(buffer, "%s %d %d %d %d", name_bmp, &pause, &r, &g, &b);
			// datos de la frame
			sprintf(filename, "%s/%s", dir, name_bmp);

			SDL_Surface *temporal;

			if ((temporal = SDL_LoadBMP(filename)) == NULL) // Cargamos la frame en cuestion.
			{
				cout << "Error cargando frame: " << count+1 << endl << "archivo: "<<filename<<endl;
				return -1;
			}

			if (r>=0)
				SDL_SetColorKey (temporal, SDL_SRCCOLORKEY, SDL_MapRGB(temporal->format, r,g,b) );

			sAnim[count].frame_img = SDL_DisplayFormat(temporal);
			SDL_FreeSurface(temporal);

			sAnim[count].pause = pause;

			if (!mW) mW = sAnim[count].frame_img->w;
			if (!mH) mH = sAnim[count].frame_img->h;

			count++;
		} // End If
    }  // End While

	fclose(fp);
	return 0;

} // END of CSpriteBase::init function !


// CSprite CLASS functions

// CSprite::init()

int CSprite::init (CSpriteBase *base, SDL_Surface *screen)
{
	mSpriteBase = base;

	if (mSpriteBase->mBuilt)
	{
		if (mSpriteBase->mNumframes > 1)
		{
			mAnimating = 1;
			mBackreplacement = SDL_DisplayFormat(mSpriteBase->sAnim[0].frame_img);
		}
		mScreen = screen;
    }
    return 0;
} // END of CSprite::init(); FUNCTION


// Funcion UpdateBG() de la clase CSprite.

void CSprite::UpdateBG()
{
	SDL_Rect srcrect;

	srcrect.x = mX;
	srcrect.y = mY;
	srcrect.w = mSpriteBase->mW;
	srcrect.h = mSpriteBase->mH;
	mOldX = mX;
	mOldY = mY;

	SDL_BlitSurface(mScreen, &srcrect, mBackreplacement, NULL);
} // FIN CSprite::ClearBG();

// Funcion draw() de la clase CSprite

void CSprite::draw()
{
	if (mAnimating == 1)
	{
		if (mLastupdate + mSpriteBase->sAnim[mFrame].pause * mSpeed < SDL_GetTicks() )
		{
			mFrame++;
			if (mFrame > mSpriteBase->mNumframes -1)
				mFrame = 0;

			mLastupdate = SDL_GetTicks();
		}
    }

	if (mDrawn == 0) mDrawn = 1;

	SDL_Rect dest;
	dest.x = mX;
	dest.y = mY;
	SDL_BlitSurface(mSpriteBase->sAnim[mFrame].frame_img, NULL, mScreen, &dest);
} // FIN CSprite::draw();


// Funcion ClearBG() de la clase CSprite.
void CSprite::ClearBG()
{
	if (mDrawn == 1)
	{
		SDL_Rect dest;
		dest.x = mOldX;
		dest.y = mOldY;
		dest.w = mSpriteBase->mW;
		dest.h = mSpriteBase->mH;
		SDL_BlitSurface(mBackreplacement, NULL, mScreen, &dest);
	}
} // FIN funcion CSprite::ClearBG();

// ------------------------- POST-Class Global Variables

// Post-Class : Variables GLOBALES.
CSpriteBase		vikingsbase, sunbase;
CSprite			vikings1, vikings2, sun;

// Post-Class : Functions.
void MostrarEscena()
{
	sun.ClearBG();
	vikings1.ClearBG();
	vikings2.ClearBG();

	sun.UpdateBG();
	vikings1.UpdateBG();
	vikings2.UpdateBG();

	sun.draw();
	vikings1.draw();
	vikings2.draw();

	SDL_Flip(screen);
}


// ------------------------- MAIN FUNCTION
int main( int argc, char *argv[] )
{
	Uint8* keys;

	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_NOPARACHUTE) < 0 )
	{
		cout << "Error iniciando video: "<< SDL_GetError() <<endl;
		return 1;
	}
	atexit(SDL_Quit);

	screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE|SDL_HWPALETTE);

	if (screen == NULL)
	{
		cout << "Error inicializando pantalla primaria: "<< SDL_GetError()<< endl;
		return 1;
	}

	// inicamos nuestras clases
	if ( vikingsbase.init("data/vikings") != 0 )
		return 1;

	if ( sunbase.init("data/sun") != 0 )
		return 1;

	// iniciamos nuestras clases de objetos
	sun.init(&sunbase, screen);
	sun.set(480, 50);
	sun.setSpeed(1);

	vikings1.init(&vikingsbase, screen);
	vikings1.set(150, 300);
	vikings1.setSpeed(1);

	vikings2.init(&vikingsbase, screen);
	vikings2.set(350,300);
	vikings2.setSpeed(1.5);

	SDL_ShowCursor(0);

	if ( LoadBG() != 0 )
	{
		cout << "Failed to load background." << endl;
	}

	DrawBG();

	int done = 0;
	SDL_Event salir;

	while (done == 0)
	{
		while (SDL_PollEvent(&salir))
		{
			if (salir.type == SDL_QUIT) { done = 1; }
			if (salir.type == SDL_KEYDOWN)
			{
				if (salir.key.keysym.sym == SDLK_ESCAPE) { done = 1; }
				if (salir.key.keysym.sym == SDLK_SPACE)  { sun.TogAnim(); }
			}
		}

		keys = SDL_GetKeyState(NULL);

		if ( keys[SDLK_UP] )   { vikings1.yadd(-1); }
		if ( keys[SDLK_DOWN] ) { vikings1.yadd(1);  }
		if ( keys[SDLK_LEFT] ) { vikings1.xadd(-1); }
		if ( keys[SDLK_RIGHT] ){ vikings1.xadd(1);  }

		MostrarEscena();

	}
	return 0;
}
*/

/*
#include <stdio.h>
#include <stdlib.h>
#include "SDL.h"


int main ( int argc, char* argv[] )
{
  SDL_Surface *bmp, **a_tiles, *finalbmp;
  SDL_Rect    src, dst;
  Uint32      rmask, gmask, bmask, amask;
  Uint32      *a_map, n_square;
  Uint8       r[32*32], g[32*32], b[32*32], a[32*32], R[32*32], G[32*32], B[32*32], A[32*32];
  int         img_w, img_h ,n_tile, x, y, i;

//////////////////////////////////////////////////////////////////////
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
  rmask = 0xff000000;
  gmask = 0x00ff0000;
  bmask = 0x0000ff00;
  amask = 0x000000ff;
#else
  rmask = 0x000000ff;
  gmask = 0x0000ff00;
  bmask = 0x00ff0000;
  amask = 0xff000000;
#endif
//////////////////////////////////////////////////////////////////////

  if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
  {
    fprintf(stderr, "Impossibile abilitare le SDL: %s.\n", SDL_GetError());
    return(1);
  }

  bmp = SDL_LoadBMP("background.bmp");

  if ( bmp == NULL )
  {
    fprintf(stderr, "Impossibile caricare l'immagine: penguin.bmp.\n");
    return(1);
  }

  img_w    = bmp->w / 32;
  img_h    = bmp->h / 32;
  n_square = img_w * img_h;

  a_tiles = (SDL_Surface**)calloc( n_square, sizeof(SDL_Surface*) );

  a_map   = (Uint32*)calloc( n_square, sizeof(Uint32) );


  src.w = 32;
  src.h = 32;

  dst.w = 32;
  dst.h = 32;
  dst.x = 0;
  dst.y = 0;

  for ( x = 0, n_tile = 0; x < img_w; x++ )
  {
    for ( y = 0; y < img_h; y++, n_tile++ )
    {

      src.x = x * 32;
      src.y = y * 32;

      a_tiles[n_tile] = SDL_CreateRGBSurface(SDL_HWSURFACE, 32, 32, 32, rmask, gmask, bmask, amask);
	  SDL_SetAlpha( a_tiles[n_tile], 0, 0 );

      if ( a_tiles[n_tile] == NULL )
      {
        fprintf(stderr, "Impossibile creare la surface: %s.\n", SDL_GetError());
        return(1);
      }

      SDL_BlitSurface(bmp, &src, a_tiles[n_tile], &dst);

    }
  }

  finalbmp = SDL_CreateRGBSurface(SDL_HWSURFACE, 32, 32*n_tile, 32, rmask, gmask, bmask, amask);

  src.x = 0;
  src.y = 0;

  for (i = 0; i < n_tile; i++)
  {
   dst.y = i * 32;
   SDL_BlitSurface (a_tiles[i], &src, finalbmp, &dst);
  }

  SDL_SaveBMP(finalbmp, "prova.bmp");

  SDL_FreeSurface(bmp);
  SDL_FreeSurface(finalbmp);

  free(a_map);
  free(a_tiles);


  return(0);
}
*/



/*
#include <stdio.h>
#include <stdlib.h>
#include "SDL.h"


int main ( int argc, char* argv[] )
{
	SDL_Surface *screen, *hw_surface;

	SDL_Init( SDL_INIT_VIDEO|SDL_INIT_NOPARACHUTE );
    atexit( SDL_Quit );

	screen = SDL_SetVideoMode( 640, 480, 32, SDL_FULLSCREEN|SDL_DOUBLEBUF|SDL_HWSURFACE );
	if( !screen ) exit(-1);

	// *** Creation of the tilemap ***
	// (I have the tilemap stored in a sw surface
	//  and blit it to the created hw surface)
	// The source softare tilemap is 512x512 pixels big.
	hw_surface = SDL_CreateRGBSurface( SDL_HWSURFACE|SDL_SRCCOLORKEY, 
									   512, 512, 32,
									   0x00ff0000, 0x0000ff00, 0x000000ff, 0);
	SDL_SetColorKey(hw_surface, SDL_SRCCOLORKEY, 0x000000);

	printf("hw_surface is %s\n", ((hw_surface->flags)&SDL_HWSURFACE)?"[hw]":"[sw]");

//	SDL_BlitSurface(sw_surface, NULL, hw_surface, NULL);

	// *** SDL_GetVideoInfo reading ***
	// All of these says "Yes" on my computer.
	// When I say "sprite blit" I mean colorkey blit.
	const SDL_VideoInfo *vid_info = SDL_GetVideoInfo();

	printf("Software->hardware blit:        %s\n", vid_info->blit_sw?"Yes":"No" );
	printf("Software->hardware sprite blit: %s\n", vid_info->blit_sw_CC?"Yes":"No" );
	printf("Hardware->hardware sprite blit: %s\n", vid_info->blit_hw_CC?"Yes":"No" );
	printf("Solid rectangle draw:           %s\n", vid_info->blit_fill?"Yes":"No" );

	return 0;
}
*/

/*
#include "SDL.h"
#include "SDL_image.h"

void WaitKey(void)
{
    SDL_Event event;

    while(1) {
         while( SDL_PollEvent(&event) )
         { 
             if (event.type == SDL_KEYDOWN)
             {
                 return;
             }
         }
     }
}

int main( int argc, char *argv[] )
{
     SDL_Surface *mainSurface;
     SDL_Event event;
     int alpha = 0;
     SDL_Surface *foreground, *temp;

     SDL_Init(SDL_INIT_EVERYTHING);
     //mainSurface = SDL_SetVideoMode(800, 600, 16, SDL_HWSURFACE | SDL_FULLSCREEN | SDL_DOUBLEBUF);
     mainSurface = SDL_SetVideoMode(800, 600, 16, SDL_FULLSCREEN);

     temp = IMG_Load("dialogimage.png");
     if ( !temp ) {
         SDL_Quit();
         return 0;
     }
     foreground = SDL_DisplayFormat(temp);
     SDL_FreeSurface(temp);

     SDL_SetColorKey(foreground, SDL_SRCCOLORKEY, SDL_MapRGB(mainSurface->format, 255, 0, 221));

     WaitKey();

     while (1) {
         while( SDL_PollEvent(&event) )
         { 
             if (event.type == SDL_KEYDOWN)
             {
                 SDL_Quit();
                 return(0);
             }
         }

         SDL_FillRect(mainSurface, NULL, SDL_MapRGB(mainSurface->format, 0,0,0) );

         //when the following line is uncommented, no image displays
         SDL_SetAlpha(foreground, SDL_SRCALPHA, alpha);
         SDL_BlitSurface(foreground, NULL, mainSurface, NULL);

         SDL_Flip(mainSurface);

         alpha += 2;
         alpha %= 255;
     }
}
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "SDL.h"

#define MAX_CMD_BUFFER  128

static int partialcmp( const char *s1, const char *s2 )
{
    return strncmp(s1, s2, strlen(s2));
}

static void status(SDL_CD *cdrom)
{
    char    status_str[128] = "unknown";
    int     status = SDL_CDStatus(cdrom);
    int     min,sec,frame;
    int     dmin,dsec,dframe;
    int     t0offset = cdrom->track[0].offset;
    int     tframes;

    switch (status)
    {
        case CD_TRAYEMPTY:
            sprintf(status_str,"No disc in drive");
            break;
        case CD_STOPPED:
            sprintf(status_str,"Stopped");
            break;
        case CD_PLAYING:
            FRAMES_TO_MSF(cdrom->cur_frame, &min, &sec, &frame);
            tframes = cdrom->track[cdrom->cur_track].offset+cdrom->cur_frame-t0offset;
            FRAMES_TO_MSF(tframes, &dmin, &dsec, &dframe);
            sprintf(status_str,"Playing n%d %02d:%02d.%02d/track %02d:%02d.%02d/disc",
                cdrom->cur_track+1,min,sec,frame,dmin,dsec,dframe);
            break;
        case CD_PAUSED:
            FRAMES_TO_MSF(cdrom->cur_frame, &min, &sec, &frame);
            tframes = cdrom->track[cdrom->cur_track].offset+cdrom->cur_frame-t0offset;
            FRAMES_TO_MSF(tframes, &dmin, &dsec, &dframe);
            sprintf(status_str,"Paused n%d %02d:%02d.%02d/track %02d:%02d.%02d/disc",
                cdrom->cur_track+1,min,sec,frame,dmin,dsec,dframe);
            break;
        case CD_ERROR:
            sprintf(status_str,"Error");
            break;
    }
    printf("%s\n", status_str); fflush(stdout);
}


static void toggle(SDL_CD *cdrom)
{
    int     status = SDL_CDStatus(cdrom);

    if ( status == CD_PLAYING )
    {
        SDL_CDPause(cdrom);
        return;
    }
    if ( status == CD_PAUSED )
    {
        SDL_CDResume(cdrom);
        return;
    }
}


int main(int argc, char *argv[])
{
	int     drive;
	int     i;
	SDL_CD *cdrom;
    char    buffer[MAX_CMD_BUFFER];

	if ( SDL_Init(SDL_INIT_CDROM) < 0 ) {
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(1);
	}
	atexit(SDL_Quit);

	if ( SDL_CDNumDrives() == 0 )
    {
		printf("No CD-ROM devices detected\n");
		exit(0);
	}
	printf("Drives available: %d\n", SDL_CDNumDrives());
	for ( i = 0; i < SDL_CDNumDrives(); ++i )
    {
		printf("Drive %d:  \"%s\"\n", i, SDL_CDName(i));
	}
    fflush(stdout);

	drive = 0;
	cdrom = SDL_CDOpen(drive);
	if ( cdrom == NULL ) {
		fprintf(stderr, "Couldn't open drive %d: %s\n", drive,
							SDL_GetError());
		exit(2);
	}

    for (;;)
    {
        printf("cdcd> "); fflush(stdout);
        fgets( buffer, sizeof(buffer), stdin );
        if ( buffer[strlen(buffer)-1] == '\n' ) buffer[strlen(buffer)-1] = 0;
        if ( buffer[strlen(buffer)-1] == '\r' ) buffer[strlen(buffer)-1] = 0;

        if ( !strcmp(buffer, "quit") )
        {
            break;
        }
        if ( !strcmp(buffer, "status") )
        {
            status(cdrom);
            continue;
        }
        if ( !strcmp(buffer, "info") )
        {
            if (CD_INDRIVE(SDL_CDStatus(cdrom)))
            {                
                printf("Album name:\n");
                printf("Total tracks:   %d       Disc playing:\n",cdrom->numtracks);
                printf("Playing:\n");
            }
            continue;
        }
        if ( !partialcmp(buffer, "play") )
        {
            char    *ptr = strchr(buffer,' ');
            int     track = 0;

            if (ptr)
            {
                track = atoi(ptr);
                track = __max(track-1,0);
            }
            if ( CD_INDRIVE(SDL_CDStatus(cdrom)) )
            {
                SDL_CDPlayTracks(cdrom, track, 0, 0, 0);
            }
            continue;
        }
        if ( !strcmp(buffer, "stop") )
        {
            SDL_CDStop(cdrom);
            continue;
        }
        if ( !strcmp(buffer, "toggle") )
        {
            toggle(cdrom);
            continue;
        }
        if ( !strcmp(buffer, "next") )
        {
            if ( SDL_CDStatus(cdrom) == CD_PLAYING)
            {
                int     track = cdrom->cur_track;

                if ( track < cdrom->numtracks) track++;
                SDL_CDPlayTracks(cdrom, track, 0, 0, 0);
            }
            continue;
        }
        if ( !strcmp(buffer, "prev") )
        {
            if ( SDL_CDStatus(cdrom) == CD_PLAYING)
            {
                int     track = cdrom->cur_track;

                if (track > 0) track--;
                SDL_CDPlayTracks(cdrom, track, 0, 0, 0);
            }
            continue;
        }
        if ( !strcmp(buffer, "eject") )
        {
            SDL_CDEject(cdrom);
            continue;
        }
        if ( !strcmp(buffer, "getvol") )
        {
            printf("         Left  Right\n");
            printf("Front     128    128\n");
            printf("Back        0      0\n"); fflush(stdout);
            continue;
        }
    }
    
	SDL_CDClose(cdrom);

	return(0);
}
